package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.KeyPageOperation;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: KeyPageOperationType
// UnionValue: Add

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("AddKeyOperation")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AddKeyOperation implements KeyPageOperation {
	public final KeyPageOperationType type = KeyPageOperationType.ADD;
	private KeySpecParams entry;

    //
	public KeySpecParams getEntry() {
	    return entry;
	}
	public void setEntry(final KeySpecParams value) {
	    this.entry = value;
	}

	public AddKeyOperation entry(final KeySpecParams value) {
	    setEntry(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.entry == null)) {
            marshaller.writeValue(2, entry);
        }
        return marshaller.array();
    }
}
